# file.make
# $Id: file.make,v 1.3 1996/10/17 16:40:34 abaird Exp $
# COPYRIGHT

# This makefile should be included in all leaves packages directory. It uses
# the FILES variable to know what are the files to be compiled.
# For example, if you have a package 'foo' containing 'a.java' and 'b.java'
# your Makefile should look like this:
# ----------
# PACKAGE=foo
# FILES=a.java b.java
# include $(MAKEDIR)/files.make
# ----------
#
# This file defines the following targets:
# all:	 to build the class files from the java files.
# clean: to clean all sub packages
# doc:   to build the appropriate documentation files from the source
# The 'doc' target uses DESTDIR variable that should point to the absolute 
# path of the target directory (in which doc files will be created).

.SUFFIXES: .java .class

.java.class:
	@@echo "Compiling " $< ; \
		javac $(JAVAFLAGS) $<; 

all:: $(FILES:.java=.class)

doc::
	javadoc -d $(DESTDIR) $(FILES)

clean::
	@@rm -rf *~ *.class

zip::
	@@echo "copying " ; \
	(cp *.class $(VPATH)); 

help::
	@@echo ; \
	echo 'Available options are'; \
	echo 'make:        creates .class files in your current dir'; \
	echo 'make clean:  cleans up your current dir, it '; \
	echo '             removes .class and .~ files'; \
	echo ; \
	echo 'More options are available by going to the top'; \
	echo 'directory and type `make`'; \
	echo ; 

