# package.make
# $Id: package.make,v 1.3 1996/10/17 16:40:35 abaird Exp $
# COPYRIGHT

# This makefile should be included in all packages Makefiles. To use it, define
# the PACKAGES variable to the set of packages defined in your directory,
# and the PACKAGE variable to this package name.
# So, if you have a 'foo' package, included in 'w3c' and containing 'bar1'
# and 'bar2' sub packages, your Makefile should look like this:
# ----------
# PACKAGE=w3c.foo
# PACKAGES=bar1 bar2
# include $(MAKEDIR)/package.make
# ----------
#
# This make file defines the following targets:
# all:	 to build the class files from the java files.
# clean: to clean all sub packages
# doc:   to build the appropriate documentation files from the source
# The 'doc' target uses DESTDIR variable that should point to the absolute 
# path of the target directory (in which doc files will be created).

all::
	@@for p in $(PACKAGES); do \
		echo 'building ' $(PACKAGE).$$p; \
		(cd $$p; make MAKEDIR=$(MAKEDIR)); \
	done

doc::
	@@for p in $(PACKAGES); do \
		echo 'doc ' $(PACKAGE).$$p; \
		(cd $$p; make MAKEDIR=$(MAKEDIR) DESTDIR=$(DESTDIR) doc); \
	done

clean::
	@@for p in $(PACKAGES); do \
		echo 'cleaning ' $(PACKAGE).$$p; \
		(cd $$p ; make MAKEDIR=$(MAKEDIR) clean) ; \
	done

zip::
	@@for p in $(PACKAGES); do \
		echo 'copying ' $(PACKAGE).$$p; \
		(mkdir $(VPATH)/$$p); \
		(cd $$p; make MAKEDIR=$(MAKEDIR) VPATH=$(VPATH)/$$p zip); \
	done

help::
	@@echo ; \
	echo 'Available options are'; \
	echo 'make:        creates .class files in your current dir'; \
	echo 'make clean:  cleans up your current dir, it '; \
	echo '             removes .class and .~ files'; \
	echo ; \
	echo 'More options are available by going to the top'; \
	echo 'directory and type `make`'; \
	echo ; 

