// ProfileCreator.java	last mod:	5/8/97	dshapiro

package w3c.pics.profiler;

import java.awt.*;
import java.util.*;
import java.io.*;
import java.net.URL;
import java.net.MalformedURLException;
import w3c.tools.tree.*;
import w3c.tools.sexpr.*;
import w3c.tools.util.IsoDate;
import w3c.pics.ui.WaitWindow;
import w3c.pics.ui.DescWindow;
import w3c.pics.ui.ErrorWindow;

/**
 * An application for creating PICS profiles.  This program implements a 
 * graphical user interface for profile creation and editing.
 **/

public class ProfileCreator extends Frame {

  Panel cardPanel = new Panel();
  Panel noPanel = new Panel();
  Panel mainPanel2 = new Panel();
  LabelPanel lpanel = null;
  HelpPanel hpanel = null;
  OptionsPanel opanel = null;
	Panel mainPanel12 = new Panel();
	TreePanel wordpanel12 = null;
  CardLayout cl = new CardLayout();
  TextArea status = new TextArea(2, 80);
  ProfileManager mainPanel8 = null;
  MenuBar mb = null;
  RatingsMenu demomenu = null;
  Menu toolsmenu = null;
	MenuItem SDesc = null;
  Hashtable inits = new Hashtable();
  String curcard = new String("Blank");
  boolean d2 = false;
  boolean d9 = false;
  boolean advmode = false;
  Vector pros = new Vector();
  TextArea buildpr = new TextArea(2, 80);
  Properties sysprop = System.getProperties();
  String opendir = sysprop.getProperty("user.dir");
  boolean eightmode = true;
  Hashtable panellist = new Hashtable();
  Hashtable serlist = new Hashtable();
  Hashtable proftable = new Hashtable();
  TextArea urls = new TextArea(10, 60);
  TextArea urls2 = new TextArea(10, 60);
	int demomode = 10;
	String filesep = sysprop.getProperty("file.separator");
	PICSRegistry pr = new PICSRegistry();
	Label prolabel = new Label();
	Hashtable dups = new Hashtable();
	boolean abmode = false;
	boolean incmode = true;
	boolean umode = false;
	DescEditor de = null;
	String eaddr = "";
	boolean ipwgmode = false;

  /**
   * Creates and initializes the program.
   **/

  public ProfileCreator() {

    super("ProfileCreator");
    status.setEditable(false);
    buildpr.setEditable(false);
    mb = new MenuBar();
    Menu filemenu = new Menu("File");
    filemenu.add(new MenuItem("New Profile"));
    filemenu.add(new MenuItem("Open Profile..."));
		// filemenu.add(new MenuItem("Open PicsRULZ..."));
    filemenu.add(new MenuItem("Save Profile..."));
		// filemenu.add(new MenuItem("Save Profile as PicsRULZ..."));
		filemenu.addSeparator();
    filemenu.add(new MenuItem("Open Ratings Editor..."));
    filemenu.add(new MenuItem("Open Ratings..."));
		// filemenu.add(new MenuItem("Open Ratings as PicsRULZ..."));
    filemenu.add(new MenuItem("Save Ratings..."));
		// filemenu.add(new MenuItem("Save Ratings as PicsRULZ..."));
    filemenu.addSeparator();
    filemenu.add(new MenuItem("Quit"));
    demomenu = new RatingsMenu("Ratings");
    mb.add(filemenu);
    mb.add(demomenu);
    toolsmenu = new Menu("Go To");
    toolsmenu.add(new MenuItem("Profile Manager"));
		toolsmenu.add(new MenuItem("Tree Viewer"));
    toolsmenu.add(new MenuItem("Preferences..."));
		toolsmenu.add(new MenuItem("Demo Modes..."));
    mb.add(toolsmenu);
    Menu othermenu = new Menu("Help");
		othermenu.add(new MenuItem("Contents"));
    othermenu.add(new MenuItem("Credits"));
		SDesc = new MenuItem("Show Service Description");
    othermenu.add(SDesc);
		SDesc.disable();
    mb.add(othermenu);
    setMenuBar(mb);
    add("Center", cardPanel);
    add("South", status);
    mainPanel8 = new ProfileManager(demomenu, pros, buildpr, pr);
    hpanel = new HelpPanel(opendir);
    lpanel = new LabelPanel();
    opanel = new OptionsPanel();
		wordpanel12 = new TreePanel(this);
    cardPanel.setLayout(cl);
    cardPanel.add("URLs", mainPanel2);
    cardPanel.add("Blank", noPanel);
    cardPanel.add("PM", mainPanel8);
    cardPanel.add("Help", hpanel);
    cardPanel.add("Source", lpanel);
    cardPanel.add("Options", opanel);
		cardPanel.add("Tree", mainPanel12);
    initnoPanel();
    cl.show(cardPanel, "Blank");
		loadPrefs();
    show();
  }

	/**
   * Handles all AWT events for the ProfileCreator application.
	 * @param event The Event to be handled.
	 * @return A boolean, <strong>true</strong> if the event was successfully 
	 * handled, <strong>false</strong> otherwise.
   **/

  public boolean handleEvent(Event event) {

    if (event.id == Event.WINDOW_DESTROY) {
      hide();
      dispose();
      System.exit(0);
      return true;
    }

		if (event.id == Event.ACTION_EVENT) {
			if (event.target instanceof Button) {
				String targ = (String) event.arg;
				if (targ.equals("New Profile")) {
					NewProfile();
					return true;
				}
				if (targ.equals("Open Profile...")) {
					// OpenProfile();
					OpenRulz();
					return true;
				}
				if (targ.equals("Save Profile...")) {
					// SaveProfile();
					SaveRulz();
					return true;
				}
				if (targ.equals("Open All")) {
					OpenAllRulz("");
					return true;
				}
				if (targ.equals("Close File")) {
					CloseItem();
					return true;
				}
				if (targ.equals("Save Forbidden URLs")) {
					SaveURLs(urls);
					return true;
				}
				if (targ.equals("Load Forbidden URLs")) {
					LoadURLs(urls);
					return true;
				}
				if (targ.equals("Clear Forbidden URLs")) {
					urls.setText("");
					return true;
				}
				if (targ.equals("Save Permitted URLs")) {
					SaveURLs(urls2);
					return true;
				}
				if (targ.equals("Load Permitted URLs")) {
					LoadURLs(urls2);
					return true;
				}
				if (targ.equals("Clear Permitted URLs")) {
					urls2.setText("");
					return true;
				}
				if (targ.equals("Start")) {
					initDemo8(eightmode, true);
					cl.show(cardPanel, "PM");
					SDesc.disable();
					validate();
					status.setText("");
					curcard = "PM";
					setTitle("Profile Manager");
					return true;
				}
				if (targ.equals("Profile Manager")) {
					initDemo8(eightmode, true);
					cl.show(cardPanel, "PM");
					SDesc.disable();
					validate();
					status.setText("");
					curcard = "PM";
					setTitle("Profile Manager");
					return true;
				}
				if (targ.equals("Credits")) {
					ShowCredits();
					return true;
				}
				if (targ.equals("Help")) {
					cl.show(cardPanel, "Help");
					SDesc.disable();
					curcard = "help";
					return true;
				}
				if (targ.equals("Edit URLs")) {
					if (!mainPanel8.getEdited().equals(""))
						LoadURLEditor();
					if (d2 == false) {
						initDemo2();
						d2 = true;
					}
					if (mainPanel8.getEdited().equals(""))
						prolabel.setText("URLs for: New Profile");
					else
						prolabel.setText("URLs for: "+mainPanel8.getEdited());
					cl.show(cardPanel, "URLs");
					SDesc.disable();
					validate();
					status.setText("");
					curcard = "URLs";
					setTitle("Forbidden/Permitted URLs");
					return true;
				}
				if (targ.equals("Edit Label Sources")) {
					if (!mainPanel8.getEdited().equals(""))
						LoadLSEditor();
					if (d9 == false) {
						lpanel.init();
						d9 = true;
					}
					cl.show(cardPanel, "Source");
					SDesc.disable();
					validate();
					status.setText("");
					curcard = "source";
					setTitle("Label Sources");
					return true;
				}
				if (targ.equals("Edit Description")) {
					if (de==null)
						de = new DescEditor(this);
					de.show();
					return true;
				}
			}
			if (event.target instanceof List) {
				if (!curcard.equals("PM"))
					return true;
				String fulltarg = (String) event.arg;
				String targ = pr.lookupName(new File(fulltarg));
				mainPanel8.changeFileLabel(remRat(targ));
				System.out.println("Editing: "+targ);
				boolean ispro = false;
				ispro = EditProfile(targ);
				if (ispro) {
					if (eightmode!=false) {
						eightmode = false;
						initDemo8(eightmode, false);
						validate();
					}
					mainPanel8.changeLabel(targ);
					mainPanel8.layout();
					validate();
				}
				else {
					if (eightmode!=true) {
						NewProfile();
					}
				}
				return true;
			}
			if (event.target instanceof Checkbox) {
				Checkbox tc = (Checkbox)event.target;
				String targ = tc.getLabel();
				if (targ.equals("Accept")) {
					abmode = true;
					return true;
				}
				if (targ.equals("Block")) {
					abmode = false;
					return true;
				}
				if (targ.equals("Include Endpoints")) {
					incmode = true;
					return true;
				}
				if (targ.equals("Exclude Endpoints")) {
					incmode = false;
					return true;
				}
				if (targ.equals("Pass")) {
					umode = true;
					return true;
				}
				if (targ.equals("Fail")) {
					umode = false;
					return true;
				}
			}
			if (event.target instanceof MenuItem) {
				String targ = (String) event.arg;
				System.out.println("Event targ: "+targ);
				reportmem();
				if (targ.equals("Quit")) {
					savePrefs();
					hide();
					dispose();
					System.exit(0);
					return true;
				}
				if (targ.equals("Open Ratings Editor...")) {
					OpenService();
					return true;
				}
				if (targ.equals("Open Profile...")) {
					// OpenProfile();
					OpenRulz();
					if (!curcard.equals("PM")) {
						initDemo8(eightmode, true);
						SDesc.disable();
						cl.show(cardPanel, "PM");
						validate();
						status.setText("");
						curcard = "PM";
						setTitle("Profile Manager");
					}
					return true;
				}
				if (targ.equals("Save Profile...")) {
					// SaveProfile();
					SaveRulz();
					return true;
				}
				/* if (targ.equals("Save Profile as PicsRULZ...")) {
					SaveRulz();
					return true;
				} */
				/* if (targ.equals("Save Ratings as PicsRULZ...")) {
					SaveRatingsRulz();
					return true;
				} */
				/* if (targ.equals("Open PicsRULZ...")) {
					OpenRulz();
					return true;
				} */
				/* if (targ.equals("Open Ratings as PicsRULZ...")) {
					OpenRatingsRulz();
					return true;
				} */
				if (targ.equals("Save Ratings...")) {
					// SaveRatings();
					SaveRatingsRulz();
					return true;
				}
				if (targ.equals("Open Ratings...")) {
					// LoadRatings();
					OpenRatingsRulz();
					return true;
				}
				if (targ.equals("New Profile")) {
					NewProfile();
					if (!curcard.equals("PM")) {
						cl.show(cardPanel, "PM");
						SDesc.disable();
						status.setText("");
						curcard = "PM";
						setTitle("Profile Manager");
					}
					return true;
				}
				if (targ.equals("Show Service Description")) {
					reshowDescWin();
					return true;
				}
				if (targ.equals("Profile Manager")) {
					initDemo8(eightmode, true);
					cl.show(cardPanel, "PM");
					SDesc.disable();
					validate();
					status.setText("");
					curcard = "PM";
					setTitle("Profile Manager");
					return true;
				}
				if (targ.equals("Advanced Options")) {
					cl.show(cardPanel, "Options");
					SDesc.disable();
					validate();
					status.setText("");
					curcard = "Options";
					setTitle("Advanced Options");
					return true;
				}
				if (targ.equals("Tree Viewer")) {
					initDemo12();
					cl.show(cardPanel, "Tree");
					SDesc.disable();
					validate();
					status.setText("");
					curcard = "tree";
					setTitle("View Tree");
					return true;
				}
				if (targ.equals("Preferences...")) {
					ShowPrefs();
					return true;
				}
				if (targ.equals("Demo Modes...")) {
					ShowModes();
					return true;
				}
				if (targ.equals("Credits")) {
					ShowCredits();
					return true;
				}
				if (targ.equals("Contents")) {
					cl.show(cardPanel, "Help");
					SDesc.disable();
					status.setText("");
					curcard = "help";
					setTitle("Help");
					return true;
				}
				if (inits.get(targ)!=null) {
					Integer i = (Integer)inits.get(targ);
					if (i.intValue()==1) {
						Service theser = (Service)serlist.get(targ);
						String thename = theser.getName();
						String thedesc = theser.getDescription();
						Panel filepanel = (Panel)panellist.get(targ);
						filepanel.removeAll();
						testOpenServiceWithName(targ, filepanel, "");
						DescWindow dwin = new DescWindow(this, thename, thedesc);
						inits.remove(targ);
						inits.put(targ, new Integer(3));
					}
					if (i.intValue()==2) {
						System.out.println("Int=2 String="+targ);
						Service theser = (Service)serlist.get(targ);
						String thename = theser.getName();
						String thedesc = theser.getDescription();
						DescWindow dwin = new DescWindow(this, thename, thedesc);
						inits.remove(targ);
						inits.put(targ, new Integer(3));
					}
					cl.show(cardPanel, targ);
					SDesc.enable();
					validate();
					status.setText("");
					curcard = targ;
					setTitle(targ);
					// System.gc();
					return true;
				}
			}
		}

		return(super.handleEvent(event));
	}

  private void reportmem() {
    long freemem = Runtime.getRuntime().freeMemory();
    long totalmem = Runtime.getRuntime().totalMemory();
    System.out.println("free: "+Long.toString(freemem));
    System.out.println("total: "+Long.toString(totalmem));
  }

	private void loadPrefs() {
		File preffile = new File(opendir, "ProfileCreator.prefs");
		if (preffile.exists()) {
			try {
				FileInputStream fis = new FileInputStream(preffile);
				DataInputStream dis = new DataInputStream(fis);
				String thisLine;
				while ((thisLine = dis.readLine())!=null) {
					if (thisLine.equals("Advanced mode:")) {
						thisLine = dis.readLine();
						Boolean newadv = new Boolean(thisLine);
						this.setAdv(newadv.booleanValue());
						System.out.println("advanced mode: "+newadv);
						continue;
					}
					else if (thisLine.equals("Default Directory:")) {
						thisLine = dis.readLine();
						this.setDir(thisLine);
						System.out.println("default dir: "+thisLine);
						continue;
					}
					else if (thisLine.equals("Email Address:")) {
						thisLine = dis.readLine();
						this.setEmail(thisLine);
						System.out.println("email address: "+thisLine);
						continue;
					}
					else if (thisLine.equals("Advanced Settings:")) {
						thisLine = dis.readLine();
						Boolean adv1 = new Boolean(thisLine);
						thisLine = dis.readLine();
						Boolean adv2 = new Boolean(thisLine);
						thisLine = dis.readLine();
						Boolean adv3 = new Boolean(thisLine);
						abmode = adv1.booleanValue();
						incmode = adv2.booleanValue();
						umode = adv3.booleanValue();
						System.out.println("adv settings: "+adv1+" "+adv2+" "+adv3);
						opanel.loadValues(abmode, incmode, umode);
						continue;
					}
					else {
						System.out.println("Unexpected stuff in prefs file.");
						continue;
					}
				}
			}
			catch (IOException e) {
				throw new RuntimeException("Error in reading prefs file");
			}
		}
		else {
			// new user
			WelcomeWindow wel = new WelcomeWindow(this);
		}
	}

	private void savePrefs() {
		File preffile = new File(opendir, "ProfileCreator.prefs");
		System.out.println("Saving prefs...");
		try {
			FileOutputStream fos = new FileOutputStream(preffile);
			PrintStream out = new PrintStream(fos);
			out.println("Advanced mode:\r");
			Boolean amode = new Boolean(advmode);
			out.println(advmode+"\r");
			out.println("Default Directory:\r");
			out.println(this.getDir()+"\r");
			out.println("Email Address:\r");
			out.println(this.getEmail()+"\r");
			out.println("Advanced Settings:\r");
			Boolean adv1 = new Boolean(abmode);
			Boolean adv2 = new Boolean(incmode);
			Boolean adv3 = new Boolean(umode);
			out.println(adv1+"\r");
			out.println(adv2+"\r");
			out.println(adv3+"\r");
			out.close();
			fos.close();
		}
		catch (IOException e) {
			throw new RuntimeException("Error in writing prefs file");
    }
	}

	/**
	 * Brings up the screen containing the Profile Manager.
	 * @see ProfileManager
	 **/

	protected void gotoPM() {
		initDemo8(eightmode, true);
		cl.show(cardPanel, "PM");
		SDesc.disable();
		validate();
		status.setText("");
		curcard = "PM";
	}

	private String remRat(String name) {
		int spacenum = name.indexOf(" ");
		if (spacenum==-1)
			return name;
		else {
			String frontstr = name.substring(0, spacenum);
			if (frontstr.endsWith(".rat"))
				return name.substring(spacenum+1);
			else
				return name;
		}
	}

  /**
   * Main procedure for the program.
   **/

  public static void main(String args[]) {
    ProfileCreator PD = new ProfileCreator();
    if (System.getProperty("os.name").equals("macos")) {
      PD.resize(600,500);
    }
    else {
			PD.resize(550,650);
    }
    if (args.length!=0) {
      System.out.println("arglength "+args.length);
      if (args[0].equals("-ipwg")) {
				System.out.println("ipwg demo mode");
				PD.ipwgmode = true;
				PD.demomode = 7;
      }
    }
  }

	private void NewProfile() {
		eightmode = true;
		initDemo8(eightmode, false);
		validate();
		urls.setText("");
		urls2.setText("");
		if (d9==false) {
			lpanel.init();
			d9 = true;
		}
		else
			lpanel.reinit();
		lpanel.setName("New Profile");
	}

  private void OpenService() {
    FileDialog fd = new FileDialog(this, "Open...", FileDialog.LOAD);
    fd.setFile("*.rat");
    File testfile = new File(opendir+filesep+"rat_files");
    if (testfile.isDirectory()) {
      fd.setDirectory(opendir+filesep+"rat_files");
    } else {
      fd.setDirectory(opendir);
    }
		/* Dimension d = this.getToolkit().getScreenSize();
		int nw = d.width*1/4;
    int nh = d.height*3/8;
    fd.move(nw, nh);	 */
		fd.show();

    String filename=fd.getFile();
    if (filename!=null) {
			WaitWindow ww = new WaitWindow(this, "Loading Service...",
						"Loading Service File...Please Wait.");
			System.out.println("Service Opened");
			System.out.println(filename);
			Panel filepanel = new Panel();
			String fullname = filename+" Untitled";
			testOpenServiceWithName(fullname, filepanel, "");
			inits.put(fullname, new Integer(2));
			panellist.put(fullname, filepanel);
			cardPanel.add(fullname, filepanel);
			removeSerMenu(fullname);
			demomenu.add(new MenuItem(fullname.trim()));
			if (curcard.equals("PM")) {
				initDemo8(eightmode, true);
				validate();
			}
			ww.hide();
			ww.dispose();
			postEvent(new Event(demomenu, Event.ACTION_EVENT, fullname));
    }
  }

	private void testOpenServiceWithName(String filename, Panel testpanel, 
		String realdir)
  {
    FileInputStream fis;
		FileInputStream fis2;
    Service Ser = null;
    boolean SimpleFiltering=false;
		int thespace = filename.indexOf(" ");
		String realfilename = filename.substring(0, thespace);
		String testname = filename.substring(thespace+1);
		StringBuffer theratfile = new StringBuffer();

    try
    {
			File testfile = new File(opendir+filesep+"rat_files");
			if (testfile.isDirectory()) {
				fis=new FileInputStream(opendir+filesep+"rat_files"+filesep+
					realfilename);
				fis2=new FileInputStream(opendir+filesep+"rat_files"+filesep+
					realfilename);
			}
			else {
				fis=new FileInputStream(realfilename);
				fis2=new FileInputStream(realfilename);
			}
    }
    catch (FileNotFoundException e)
    {
			System.out.println("File not found");
			return;
    }
    catch (IOException e)
    {
			System.out.println("IO Exception");
			return;
    }
    try
    {
			Ser=new Service(fis, this);
    }
    catch (PICSException e)
    {
			try
			{fis.close();}
			catch (IOException ei) {System.out.println("Closing error");}
			System.out.println("PICS Service Parsing Error:");
			System.out.println(e);
    }
    catch (IOException e)
    {System.out.println("IO error");}
    // Put the Interface Widgets of the New Service
    Ser.newInterface(testpanel,SimpleFiltering, status);
		File itexists = pr.lookupFile(filename);
		if (itexists!=null) {
			File tester = null;
			if (realdir.equals(""))
				tester = new File(opendir+filesep, testname);
			else
				tester = new File(realdir, testname);
			int fnum = findNum(filename, tester);
				switch (fnum) {
					case 0:
						if (dups.get(filename)==null)
							dups.put(filename, new Integer(2));
						else {
							Integer thenum = (Integer)dups.get(filename);
							int numval = thenum.intValue();
							numval++;
							dups.put(filename, new Integer(numval));
						}
						String snum = ((Integer)dups.get(filename)).toString();
						serlist.put(filename+"("+snum+")", Ser);
						break;
					case 1:
						serlist.put(filename, Ser);
						break;
					default:
						serlist.put(filename+"("+fnum+")", Ser);
				}
			/* if (!itexists.equals(tester)) {
				if (dups.get(filename)==null)
					dups.put(filename, new Integer(2));
				else {
					Integer thenum = (Integer)dups.get(filename);
					int numval = thenum.intValue();
					numval++;
					dups.put(filename, new Integer(numval));
				}
				String snum = ((Integer)dups.get(filename)).toString();
				serlist.put(filename+"("+snum+")", Ser);
			}
			else
				serlist.put(filename, Ser);*/
		}
		else
			serlist.put(filename, Ser);
		System.out.println("serlist size: "+serlist.size());
		DataInputStream dis2;
		try {
			dis2 = new DataInputStream(fis2);
			String thisLine = null;
			thisLine = dis2.readLine();
			theratfile.append(thisLine+"\r\n");
			while ((thisLine = dis2.readLine())!=null) {
				theratfile.append("\t\t\t"+thisLine+"\r\n");
			}
			dis2.close();
		}
		catch (Exception e) {
			System.out.println("Error reading ratfile.");
		}
		lpanel.addSource(realfilename, Ser.getRatingservice(), 
			Ser.getRatingsystem(), theratfile);
    testpanel.validate();
    try {
			fis2.close();
      fis.close();
    }
    catch (Exception e) {
      System.out.println("Error closing .rat file");
    }
  }


  private void OpenProfile() {
    FileDialog fd = new FileDialog(this, "Open...", FileDialog.LOAD);
    fd.setFile("*.pro");
    File testfile = new File(opendir+filesep+"pro_files");
    if (testfile.isDirectory()) {
      fd.setDirectory(opendir+filesep+"pro_files");
    } else {
      fd.setDirectory(opendir);
    }
    fd.show();

    String filename=fd.getFile();
		String dirname = fd.getDirectory();
    if (filename!=null) {
			System.out.println("Profile Opened");
			System.out.println(filename);
			File itexists = pr.lookupFile(filename);
			if (itexists!=null) {
				File tester = new File(dirname, filename);
				int fnum = findNum(filename, tester);
				switch (fnum) {
					case 0:
						if (dups.get(filename)==null)
							dups.put(filename, new Integer(2));
						else {
							Integer thenum = (Integer)dups.get(filename);
							int numval = thenum.intValue();
							numval++;
							dups.put(filename, new Integer(numval));
						}
						String snum = ((Integer)dups.get(filename)).toString();
						String newfilename = filename+"("+snum+")";
						Profile newprof = new Profile(filename, opendir);
						proftable.put(newfilename, newprof);
						pros.addElement(newfilename);
						pr.addPair(newfilename, new File(dirname, filename));
						break;
					case 1:
						Profile newprof1 = new Profile(filename, opendir);
						proftable.put(filename, newprof1);
						if (!pros.contains(filename))
							pros.addElement(filename);
						// pr.addPair(filename, new File(dirname, filename));
						break;
					default:
						String newfilename2 = filename+"("+fnum+")";
						Profile newprof2 = new Profile(filename, opendir);
						proftable.put(newfilename2, newprof2);
						if (!pros.contains(newfilename2))
							pros.addElement(newfilename2);
						// pr.addPair(newfilename2, new File(dirname, filename));
				}
			/* Profile testprof = (Profile)proftable.get(filename);
			if (testprof!=null) {
				System.out.println("File already open!");
				ErrorWindow ew = new ErrorWindow(this, "That file is already open!");
				return;
			}	*/
			}
			else {
				Profile newprof = new Profile(filename, opendir);
				proftable.put(filename, newprof);
				pros.addElement(filename);
				pr.addPair(filename, new File(dirname, filename));
			}
			System.out.println(pr.toString());
			if (curcard.equals("PM")) {
				initDemo8(eightmode, true);
				validate();
			}
    }
  }

  private void SaveProfile() {
    FileDialog fd = new FileDialog(this, "Save As...", FileDialog.SAVE);
    fd.setFile("");
    fd.setDirectory(opendir);
    fd.show();
    String filename = fd.getFile();
		String dirname = fd.getDirectory();
    if (filename!=null) {
      // hack to fix bug in Win32 FileDialog (maybe others...)
      if (filename.endsWith(".*.*"))
			{
				filename=filename.substring(0,filename.length()-4);
			}
      if (curcard.equals("PM")) {
				try {
					FileOutputStream fos = new FileOutputStream(filename);
					PrintStream out = new PrintStream(fos);
					Profile newprof = new Profile(buildpr.getText());
					Vector newrats = newprof.getRats();
					out.println(buildpr.getText()+"\r");
					if (!newrats.isEmpty()) {
						Enumeration erats = newrats.elements();
						while (erats.hasMoreElements()) {
							String theout = (String)erats.nextElement();
							String realname = mainPanel8.findFullName(theout);
							Service Ser = (Service)serlist.get(realname);
							newprof.putState(Ser.getFilter(theout).toString());
							out.println(Ser.getFilter(theout).toString()+"\r");
							File fileobj = pr.lookupFile(realname);
							String fstring = fileobj.toString();
							newprof.addFile(fstring);
							out.println(fstring+"\r");
							out.println(realname+"\r");
							newprof.putFullName(realname);
						}
					}
					String biglist = urls.getText();
					StringTokenizer bigtok = new StringTokenizer(biglist);
					out.println("Begin URLs\r");
					while (bigtok.hasMoreTokens()) {
						String curtok = bigtok.nextToken();
						try {
							URL testurl = new URL(curtok);
							out.println(curtok+"\r");
							newprof.addURL(curtok);
						}
						catch (MalformedURLException e) {
							System.out.println("Bad URL: "+curtok);
						}
					}
					out.println("End URLs\r");
					biglist = urls2.getText();
					bigtok = new StringTokenizer(biglist);
					out.println("Begin URLs2\r");
					while (bigtok.hasMoreTokens()) {
						String curtok = bigtok.nextToken();
						try {
							URL testurl = new URL(curtok);
							out.println(curtok+"\r");
							newprof.addURL2(curtok);
						}
						catch (MalformedURLException e) {
							System.out.println("Bad URL2: "+curtok);
						}
					}
					out.println("End URLs2\r");
					if (d9 == false) {
						lpanel.init();
						d9 = true;
					}
					out.println("Label Sources:\r");
					String active = lpanel.checks();
					String[] lsources = lpanel.sourceStrings();
					for (int i=0; i<4; i++) {
						if (active.charAt(i)=='1') {
							out.println(lsources[i]+"\r");
							newprof.addLSource(lsources[i]);
						}
					}
					lpanel.setName(filename);
					proftable.put(filename, newprof);
					if (!pros.contains(filename))
						pros.addElement(filename);
					pr.addPair(filename, new File(dirname, filename));
					System.out.println(pr.toString());
					if (curcard.equals("PM")) {
						initDemo8(eightmode, true);
						validate();
					}
					out.close();
					fos.close();
				}
				catch (IOException e) {
					throw new RuntimeException("Error in writing file" + filename);
				}
      }
    }
  }

  private void SaveRatings() {
    Service Ser = (Service)serlist.get(curcard);
    if (Ser==null) {
      System.out.println("error -- not on service page");
			System.out.println("curcard = "+curcard);
      ErrorWindow ew = new ErrorWindow(this, "Can only Save Ratings while "+
				       "on a Service Page");
      return;
    }
    FileDialog fd = new FileDialog(this, "Save As...", FileDialog.SAVE);
    fd.setFile("");
    fd.setDirectory(opendir);
    fd.show();
    String filename = fd.getFile();
		String dirname = fd.getDirectory();
    if (filename!=null) {
      // hack to fix bug in Win32 FileDialog (maybe others...)
      if (filename.endsWith(".*.*"))
				{
					filename=filename.substring(0,filename.length()-4);
				}
      try {
				FileOutputStream fos = new FileOutputStream(filename);
				PrintStream out = new PrintStream(fos);
				out.print(Ser.getFilter(curcard));
				out.close();
				fos.close();
			}
      catch (IOException e) {
				throw new RuntimeException("Error in writing file" + filename);
      }
			int thespace = curcard.indexOf(" ");
			String oldname = curcard.substring(thespace+1);
			String sername = curcard.substring(0, thespace);
			String newname = sername+" "+filename;
			System.out.println("Untitled");
			inits.remove(curcard);
			Service s = (Service)serlist.remove(curcard);
			Panel thepanel = (Panel)panellist.remove(curcard);
			cardPanel.remove(thepanel);
			removeSerMenu(curcard);
			panellist.put(newname, thepanel);
			cardPanel.add(newname, thepanel);
			serlist.put(newname, s);
			inits.put(newname, new Integer(3));
 			demomenu.add(new MenuItem(newname.trim()));
			setTitle(newname);
			curcard = newname;
			cl.show(cardPanel, newname);
			SDesc.enable();
			validate();
			pr.addPair(curcard, new File(dirname, filename));
			System.out.println(pr.toString());
    }
  }

	private void removeSerMenu(String fullname) {
		demomenu.remove(fullname);
	}

	private int findNum(String name, File realfile) {
		Integer imax = (Integer)dups.get(name);
		int max = 0;
		if (imax==null)
			max = 0;
		else
			max = imax.intValue();
		File tester = pr.lookupFile(name);
		if (tester.equals(realfile))
			return 1;
		for (int i=2; i<max+1; i++) {
			tester = pr.lookupFile(name+"("+i+")");
			if (tester==null)
				return i;
			if (tester.equals(realfile))
				return i;
		}
		return 0;
	}

  private void LoadRatings() {
    FileDialog fd = new FileDialog(this, "Open...", FileDialog.LOAD);
    fd.setDirectory(opendir);
    fd.show();

    String datafilename=fd.getFile();
		String dirname = fd.getDirectory();
    if (datafilename!=null) {
      System.out.println("Ratings Opened");
      System.out.println(datafilename);
			int r = curcard.indexOf(" ");
			if (r==-1) {
				ErrorWindow ew = new ErrorWindow(this, "Can only Load Ratings while "+
							"on a Service Editor Page");
				return;
			}
			String ratfile = curcard.substring(0, r);
			File testfile = new File(opendir+filesep+"rat_files", ratfile);
			WaitWindow ww = new WaitWindow(this, "Loading Ratings...",
							"Loading Ratings...Please Wait.");
			Panel filepanel = new Panel();
			String fullname = ratfile+" "+datafilename;
			testOpenServiceWithName(fullname, filepanel, dirname);
			File itexists = pr.lookupFile(fullname);
			if (itexists!=null) {
				File tester = new File(dirname, datafilename);
				/* if (!itexists.equals(tester)) {
					String snum = ((Integer)dups.get(fullname)).toString();
					fullname = fullname+"("+snum+")";
				}	*/
				int fnum = findNum(fullname, tester);
				switch (fnum) {
					case 0:
						fullname = fullname+"("+((Integer)dups.get(fullname)).toString()+
							")";
						break;
					case 1:
						break;
					default:
						fullname = fullname+"("+fnum+")";
				}
			}
      Service Ser = (Service)serlist.get(fullname);
      if (Ser==null) {
				System.out.println("Error loading ratings.");
				ErrorWindow ew = new ErrorWindow(this, "Can only Load Ratings while "+
								 "on a Service Editor Page");
				return;
      }
      FileInputStream fis;
      Filter Fil;
      try {
				fis=new FileInputStream(datafilename);
      }
      catch (FileNotFoundException e)
			{
				System.out.println("File not found");
				return;
			}
      catch (IOException e)
			{
				System.out.println("IO Exception");
				return;
			}
			boolean haderr = false;
      try {
			Fil=new Filter(fis, ratfile);
			System.out.println(Fil);
			haderr = Ser.setFilter(Fil);
			Ser.resetError();
      }
      catch (PICSException e)
			{
				System.out.println("PICS Filter Parsing Error:");
				System.out.println(e);
				haderr = true;
			}
      catch (IOException e)
			{
				System.out.println("IO error");
				haderr = true;
			}
      try {
				fis.close();
      }
      catch (IOException ei) {
				System.out.println("Closing error");
      }
			if (haderr)	{
				ww.hide();
				ww.dispose();
				System.out.println(pr.toString());
				return;
			}
			inits.put(fullname, new Integer(2));
			panellist.put(fullname, filepanel);
			cardPanel.add(fullname, filepanel);
			removeSerMenu(fullname);
			demomenu.add(new MenuItem(fullname.trim()));
			ww.hide();
			ww.dispose();
			postEvent(new Event(demomenu, Event.ACTION_EVENT, fullname));
			pr.addPair(curcard, new File(dirname, datafilename));
			System.out.println(pr.toString());
    }
  }

  /**
   * Reloads the screen for the current service
   * @param fil The Filter read from a save file.
   **/

  protected void reload(Filter fil) {
    Service Ser = (Service)serlist.get(fil.getService());
    if (Ser==null) {
      System.out.println("Error loading ratings.");
      return;
    }
    Ser.setFilter(fil);
    System.out.println("Did reload "+fil.getService());
  }

  /* private void ResetService() {
    String name = mainPanel8.resetSelectedService();
    if (name!=null) {
			System.out.println("Reset Service name "+name);
			Service Ser = (Service)serlist.get(name);
			Ser.clearService();
    }
  } */

	/*private void ResetServiceMenu() {
		Service Ser = (Service)serlist.get(curcard);
		if (Ser!=null) {
			mainPanel8.selectResetService(curcard);
			Ser.clearService();
		}
	}	 */

  private void ShowPrefs() {
    PrefWindow pwin = new PrefWindow(this);
  }

	private void ShowModes() {
		ModeWindow mwin = new ModeWindow(this);
	}

  private boolean EditProfile(String name) {
    String info = new String("");
		boolean retval = false;
    Profile theprof = (Profile)proftable.get(name);
    if (theprof!=null) {
      info = theprof.getStringRep();
			retval = true;
		}
    mainPanel8.setEditor(info);
		return retval;
  }

  private boolean PMOpenService(String filename, String info) {
    if (inits.get(filename)==null) {
      Panel filepanel = new Panel();
      testOpenServiceWithName(filename, filepanel, "");
      inits.put(filename, new Integer(2));
      panellist.put(filename, filepanel);
      cardPanel.add(filename, filepanel);
      demomenu.add(new MenuItem(filename.trim()));
    }
    Service Ser = (Service)serlist.get(filename);
    if (Ser==null) {
      System.out.println("Error loading ratings.");
      return true;
    }
    Filter Fil = null;
    StringBufferInputStream fis = new StringBufferInputStream(info);
		int thespace = filename.indexOf(" ");
		String realfilename = filename.substring(0, thespace);
    try {
      Fil=new Filter(fis, realfilename);
      System.out.println(Fil);
      Ser.setFilter(Fil);
    }
    catch (PICSException e)
      {
				System.out.println("PICS Filter Parsing Error:");
				System.out.println(e);
      }
    catch (IOException e)
      {
				System.out.println("IO error");
      }
    try {
      fis.close();
    }
    catch (IOException ei) {
      System.out.println("Closing error");
    }
    if (Ser.haveError()) {
      Ser.resetError();
      return false;
    }
    else
      return true;
  }

	private void LoadURLEditor() {
		String name = mainPanel8.getEdited();
		Profile theprof = (Profile)proftable.get(name);
		if (theprof!=null) {
			urls.setText("");
			Vector profurl = theprof.getURLs();
			if (!profurl.isEmpty()) {
				Enumeration urat = profurl.elements();
				while (urat.hasMoreElements()) {
					String uname = (String)urat.nextElement();
					urls.appendText(uname+"\n");
				}
			}
			urls2.setText("");
			Vector profurl2 = theprof.getURLs2();
			if (!profurl2.isEmpty()) {
				Enumeration urat2 = profurl2.elements();
				while (urat2.hasMoreElements()) {
					String uname2 = (String)urat2.nextElement();
					urls2.appendText(uname2+"\n");
				}
			}
		}
	}

	private void LoadLSEditor() {
		String name = mainPanel8.getEdited();
		Profile theprof = (Profile)proftable.get(name);
		if (theprof!=null) {
			Vector ls = theprof.getLSources();
			if (!ls.isEmpty()) {
				Enumeration lsrat = ls.elements();
				int counter = 1;
				if (d9 == false) {
					lpanel.init();
					d9 = true;
				}
				while (lsrat.hasMoreElements()) {
					String sname = (String)lsrat.nextElement();
					// lpanel.addSource(sname, "http://foo.com/", "http://bar.edu/");
				}
				lsrat = ls.elements();
				while (lsrat.hasMoreElements()) {
					String lsname = (String)lsrat.nextElement();
					System.out.println("lsname: "+lsname);
					lpanel.makeSetting(lsname, counter);
					counter++;
				}
				while (counter<5) {
					lpanel.emptySetting(counter);
					counter++;
				}
			}
			lpanel.setName(name);
		}
	}

  private void OpenAll() {
    String name = mainPanel8.getEdited();
    if (!name.equals("")) {
      Profile theprof = (Profile)proftable.get(name);
      if (theprof!=null) {
				WaitWindow ww = new WaitWindow(this, "Opening Files...",
							"Opening Files...Please Wait.");
				Vector profpro = theprof.getPros();
				if (!profpro.isEmpty()) {
					Enumeration epro = profpro.elements();
					while (epro.hasMoreElements()) {
						String pename = (String)epro.nextElement();
						if (pros.indexOf(pename)==-1) {
							Profile newprof = new Profile(pename, opendir);
							pr.addPair(pename, new File(opendir, pename));
							proftable.put(pename, newprof);
							pros.addElement(pename);
						}
					}
				}
				Vector profrat = theprof.getRats();
				Vector profstring = theprof.getStates();
				Vector proffile = theprof.getFiles();
				Vector proffull = theprof.getFullNames();
				boolean noerr = true;
				boolean haderr = false;
				if (!profrat.isEmpty()) {
					Enumeration erat = profrat.elements();
					Enumeration srat = profstring.elements();
					Enumeration frat = proffile.elements();
					Enumeration fullrat = proffull.elements();
					while (erat.hasMoreElements()) {
						String ename = (String)erat.nextElement();
						String fullrname = (String)fullrat.nextElement();
						ww.changeMessage("Opening Ratings File: "+ename+"...");
						String realfname = (String)frat.nextElement();
						noerr = PMOpenService(fullrname, (String)srat.nextElement());
						pr.addPair(fullrname, new File(realfname));
						System.out.println(pr.toString());
						if (!noerr)
							haderr = true;
					}
				}
				urls.setText("");
				ww.changeMessage("Loading URL lists...");
				Vector profurl = theprof.getURLs();
				if (!profurl.isEmpty()) {
					Enumeration urat = profurl.elements();
					while (urat.hasMoreElements()) {
						String uname = (String)urat.nextElement();
						urls.appendText(uname+"\n");
					}
				}
				urls2.setText("");
				Vector profurl2 = theprof.getURLs2();
				if (!profurl2.isEmpty()) {
					Enumeration urat2 = profurl2.elements();
					while (urat2.hasMoreElements()) {
						String uname2 = (String)urat2.nextElement();
						urls2.appendText(uname2+"\n");
					}
				}
				Vector ls = theprof.getLSources();
				if (!ls.isEmpty()) {
					ww.changeMessage("Loading Label Sources...");
					Enumeration lsrat = ls.elements();
					int counter = 1;
					if (d9 == false) {
						lpanel.init();
						d9 = true;
					}
					while (lsrat.hasMoreElements()) {
						String lsname = (String)lsrat.nextElement();
						System.out.println("lsname: "+lsname);
						lpanel.makeSetting(lsname, counter);
						counter++;
					}
					while (counter<5) {
						lpanel.emptySetting(counter);
						counter++;
					}
				}
				if (haderr)
					ErrorWindow ewin = new ErrorWindow(this, "There was an error in "+
										 "loading these files.  Please "+
										 "try again.", 400);
				initDemo8(eightmode, true);
				validate();
				ww.hide();
				ww.dispose();
      }
    }
  }

  /**
   * Redisplays the DescWindow with the description of the currently opened
   * service.
	 * @see DescWindow
   **/

  public void reshowDescWin() {
    Service theser = (Service)serlist.get(curcard);
    if (theser!=null) {
      String thename = theser.getName();
      String thedesc = theser.getDescription();
      DescWindow dwin = new DescWindow(this, thename, thedesc);
    }
  }

  private void SaveURLs(TextArea ins) {
    FileDialog fd = new FileDialog(this, "Save As...", FileDialog.SAVE);
    fd.setFile("");
    fd.setDirectory(opendir);
    fd.show();
    String filename = fd.getFile();
    if (filename!=null) {
      // hack to fix bug in Win32 FileDialog (maybe others...)
      if (filename.endsWith(".*.*"))
			{
				filename=filename.substring(0,filename.length()-4);
			}
      try {
				FileOutputStream fos = new FileOutputStream(filename);
				PrintStream out = new PrintStream(fos);
				if (curcard.equals("URLs")) {
					String biglist = ins.getText();
					StringTokenizer bigtok = new StringTokenizer(biglist);
					while (bigtok.hasMoreTokens()) {
						String curtok = bigtok.nextToken();
						try {
							URL testurl = new URL(curtok);
							out.println(curtok);
						}
						catch (MalformedURLException e) {
							System.out.println("Bad URL: "+curtok);
						}
					}
				}
				else {
					out.print(curcard);
				}
				out.close();
				fos.close();
      }
      catch (IOException e) {
				throw new RuntimeException("Error in writing file" + filename);
      }
    }
  }

  private void LoadURLs(TextArea ins) {
    FileDialog fd = new FileDialog(this, "Open...", FileDialog.LOAD);
    fd.setDirectory(opendir);
    fd.show();

    String filename=fd.getFile();
    FileInputStream fis;
    if (filename!=null) {
      System.out.println("URLs Opened");
      System.out.println(filename);
      try {
				fis = new FileInputStream(filename);
				try {
					DataInputStream dis = new DataInputStream(fis);
					try {
						String myline;
						ins.setText("");
						while ((myline = dis.readLine())!=null) {
							try {
								URL testurl = new URL(myline);
								ins.appendText(myline+"\n");
							}
							catch (MalformedURLException e) {
								System.out.println("Bad URL: "+myline);
							}
						}
					}
					catch (Exception e) {
						System.out.println("Error: "+e);
					}
					try {
						dis.close();
						fis.close();
					}
					catch (Exception e) {
						System.out.println("I/O Error closing file.");
					}
				}
				catch (Exception e) {
					System.out.println("Error: "+e);
				}
      }
      catch (Exception e) {
				System.out.println("Failed to open file: "+filename);
      }
    }
  }

  private void ShowCredits() {
    DescWindow cwin = new DescWindow(this, "Credits", "W3C PICS Profile "+
				     "Manager Demo Created by: David "+
				     "Shapiro dshapiro@mit.edu Some source "+
				     "code from PICS Demo by: Ching Law "+
				     "ching@mit.edu");
  }

  private void initnoPanel() {
    GridLayout nogl = new GridLayout(3,1);
    noPanel.setLayout(nogl);
    Label title = new Label("W3C", Label.CENTER);
    title.setFont(new Font("Helvetica", Font.PLAIN, 36));
    Label moretitle = new Label("PICS Profile Manager", Label.CENTER);
    moretitle.setFont(new Font("Helvetica", Font.PLAIN, 18));
    noPanel.add(title);
    noPanel.add(moretitle);
    Panel buttons = new Panel();
    Button s = new Button("Start");
    Button a = new Button("Credits");
    Button h = new Button("Help");
    buttons.add(s);
    buttons.add(h);
    buttons.add(a);
    noPanel.add(buttons);
  }

  private void initDemo2() {
		GridLayout mp2gl = new GridLayout(8,1);
		mainPanel2.setLayout(mp2gl);
		prolabel.setFont(new Font("Helvetica", Font.PLAIN, 18));
		mainPanel2.add(prolabel);
    Label urllabel = new Label("Enter Forbidden URLs here:", Label.LEFT);
  	urllabel.setFont(new Font("Helvetica", Font.BOLD, 12));
		Panel bpanel = new Panel();
    Button saveurls = new Button("Save Forbidden URLs");
    Button loadurls = new Button("Load Forbidden URLs");
    Button clearurls = new Button("Clear Forbidden URLs");
    mainPanel2.add(urllabel);
    mainPanel2.add(urls);
    bpanel.add(saveurls);
    bpanel.add(loadurls);
    bpanel.add(clearurls);
    mainPanel2.add(bpanel);
		Panel bpanel2 = new Panel();
		Label urllabel2 = new Label("Enter Permitted URLs here:", Label.LEFT);
		urllabel2.setFont(new Font("Helvetica", Font.BOLD, 12));
		mainPanel2.add(urllabel2);
		mainPanel2.add(urls2);
		Button saveurls2 = new Button("Save Permitted URLs");
    Button loadurls2 = new Button("Load Permitted URLs");
    Button clearurls2 = new Button("Clear Permitted URLs");
		bpanel2.add(saveurls2);
    bpanel2.add(loadurls2);
    bpanel2.add(clearurls2);
    mainPanel2.add(bpanel2);
		Button retbut = new Button("Profile Manager");
		Panel retpanel = new Panel();
		retpanel.add(retbut);
		mainPanel2.add(retpanel);
  }

  private void initDemo8(boolean mode, boolean refresh) {
    // demo for Profile Manager
    if (!refresh)
      mainPanel8.changeMode(mode);
    else {
      mainPanel8.changeMode(mode);
      mainPanel8.refreshList();
    }
  }

	void initDemo12() {
		mainPanel12.removeAll();
		String idir = opendir+filesep+"icons"+filesep;
		TreeHandler handler = new PICSTreeHandler(this, idir);
    TreeBrowser leftPanel = new TreeBrowser(handler);
		// BorderLayout bl12 = new BorderLayout();
		// mainPanel12.setLayout(bl12);
		// mainPanel12.add("West", leftPanel);
		//leftPanel.resize(150, 400);
		GridLayout gl12 = new GridLayout(1,2);
		mainPanel12.setLayout(gl12);
		wordpanel12.init();
		mainPanel12.add(leftPanel);
		mainPanel12.add(wordpanel12);
	}

	/**
	 * Displays a particular String in the view tree portion of the program.
	 * @param name A String with the name to display.
	 * @param parent A String with the name of the parent of the node being 
	 * displayed.
	 **/

	public void displayName(String name, String parent) {
		wordpanel12.displayName(name, parent);
	}

  /**
   * Returns a boolean indicating if the user is in advanced mode or not.
   * @return A boolean, <strong>true</strong> if in advanced mode,
   * <strong>false</strong> if not.
   **/

  protected boolean getAdv() {
    return(advmode);
  }

  /**
   * Changes the advanced mode setting of the ProfileCreator.
   * @param newadv The new setting for the advanced mode.
   **/

  protected void setAdv(boolean newadv) {
    if (advmode!=newadv) {
      advmode = newadv;
      if (advmode)
				toolsmenu.add(new MenuItem("Advanced Options"));
      else
				toolsmenu.remove(4);
    }
  }

  /**
   * Changes the working directory of the program.
   * @param dir The new working directory.
   **/

  protected void setDir(String dir) {
    opendir = dir;
  }

  /**
   * Returns the current working directory of the program.
   * @return A String, representing the current working directory.
   **/

  protected String getDir() {
    return(opendir);
  }

	/**
	 * Returns the integer value representing the current mode of the 
	 * ProfileCreator.
	 * @return An int, the current demomode.
	 **/

	protected int getDemomode() {
		return(demomode);
	}

	/**
	 * Changes the current demomode.
	 * @param newmode The new demomode.
	 **/

	protected void setDemomode(int newmode) {
		if (demomode!=newmode) {
			demomode = newmode;
			Enumeration files = inits.keys();
      while (files.hasMoreElements()) {
				String thename = (String)files.nextElement();
				inits.remove(thename);
				inits.put(thename, new Integer(1));
      }
			if (newmode==4) {
				Toolkit tk = Toolkit.getDefaultToolkit();
				Dimension d = tk.getScreenSize();
				move(0,0);
				resize(d);
			}
			else {
			  if (System.getProperty("os.name").equals("macos")) {
          resize(600,500);
        }
        else {
    			resize(550,650);
        }
      }
    }
	}

	/**
	 * Returns the email address currently stored in the user preferences.
	 * @return A String containing the email address.
	 **/

	public String getEmail() {
		return(eaddr);
	}

	/**
	 * Changes the email address currently stored in the user preferences.
	 * @param newaddr The new email address to store.
	 **/

	public void setEmail(String newaddr) {
		eaddr = newaddr;
	}

  /**
   * Redraws the screen for a particular service.
   * @param sname The name of the service.
   **/

  protected void refresh(String sname) {
    Panel filepanel = (Panel)panellist.get(sname);
    if (filepanel!=null) {
      filepanel.removeAll();
      testOpenServiceWithName(sname, filepanel, "");
      inits.remove(sname);
      inits.put(sname, new Integer(3));
      status.setText("");
    }
    System.out.println("Did refresh "+sname);
  }

  private void CloseItem() {
    String theitem = mainPanel8.profs.getSelectedItem();
		if (theitem==null)
			return;
		/* int lastslash = theitem.lastIndexOf(filesep);
		String realitem = theitem.substring(lastslash+1);
		realitem = mainPanel8.findFullName(realitem);	*/
		String realitem = pr.lookupName(new File(theitem));
    if (inits.get(realitem)!=null) {
			// is a .rat
			mainPanel8.profs.delItem(mainPanel8.profs.getSelectedIndex());
			inits.remove(realitem);
			cardPanel.remove((Panel)panellist.get(realitem));
			panellist.remove(realitem);
			serlist.remove(realitem);
			removeSerMenu(realitem);
			initDemo8(eightmode, true);
			validate();
			return;
    }
    else {
      if (proftable.get(realitem)!=null) {
				// is a .pro
				mainPanel8.profs.delItem(mainPanel8.profs.getSelectedIndex());
				proftable.remove(realitem);
				pros.removeElement(realitem);
				initDemo8(eightmode, true);
				validate();
      }
      else
				return;
    }
  }


	private void SaveRulz() {
    FileDialog fd = new FileDialog(this, "Save As...", FileDialog.SAVE);
    fd.setFile("");
    fd.setDirectory(opendir);
    fd.show();
    String filename = fd.getFile();
		String dirname = fd.getDirectory();
    if (filename!=null) {
      // hack to fix bug in Win32 FileDialog (maybe others...)
      if (filename.endsWith(".*.*"))
			{
				filename=filename.substring(0,filename.length()-4);
			}
      if (curcard.equals("PM")) {
				try {
					FileOutputStream fos = new FileOutputStream(filename);
					PrintStream out = new PrintStream(fos);
					Profile newprof = new Profile(buildpr.getText(), filename, dirname);
					if (!newprof.getPros().isEmpty()) {
						Vector prolist = newprof.getPros();
						// mergeFilters(prolist, newprof);
					} 
					out.println("(PicsRule-1.0\r");
					out.println("\t(\r");

					// failURL
					String biglist = urls.getText();
					StringTokenizer bigtok = new StringTokenizer(biglist);
					if (bigtok.countTokens()>0) {
						out.print("\tfailURL (");
						while (bigtok.hasMoreTokens()) {
							String curtok = bigtok.nextToken();
							try {
								URL testurl = new URL(curtok);
								out.print(" \""+curtok+"\"");
								newprof.addURL(curtok);
							}
							catch (MalformedURLException e) {
								System.out.println("Bad URL: "+curtok);
							}
						}
						out.println(")\r");
					}

					// passURL
					biglist = urls2.getText();
					bigtok = new StringTokenizer(biglist);
					if (bigtok.countTokens()>0) {
						out.print("\tpassURL (");
						while (bigtok.hasMoreTokens()) {
							String curtok = bigtok.nextToken();
							try {
								URL testurl = new URL(curtok);
								out.print(" \""+curtok+"\"");
								newprof.addURL2(curtok);
							}
							catch (MalformedURLException e) {
								System.out.println("Bad URL2: "+curtok);
							}
						}
						out.println(")\r");
					}

					// name clause: rulename and description 

					out.print("\tname (");
					
					// rulename

					out.println("rulename \""+filename+"\"\r");

					// description

					if (de!=null) {
						if ((!de.getDesc().equals("")) && (de.getDesc()!=null))
							out.print("\t\tdescription \""+de.getDesc()+"\"");
						else
							out.print("\t\tdescription \""+filename+" created by "+
							"ProfileCreator application\"");
					}
					else
	 					out.print("\t\tdescription \""+filename+" created by "+
						"ProfileCreator application\"");

					out.println(")\r");

					// source	-- sourceURL

					if (de!=null) {
						if ((!de.getSource().equals("")) && (de.getSource()!=null))
							out.println("\tsource (sourceURL \""+de.getSource()+"\"\r");
						else
							out.println("\tsource (sourceURL \"http://title.w3.org/\"\r");
					}
					else
						out.println("\tsource (sourceURL \"http://title.w3.org/\"\r");

					// source -- creationTool

					out.println("\t\tcreationTool \"ProfileCreator/0.01\"\r");

					// source -- author

					out.println("\t\tauthor \""+getEmail()+"\"\r");

					// source -- lastModified

					// construct a quoted-ISO-date

					IsoDate now = new IsoDate();

					out.print("\t\tlastModified "+now);

					out.println(")\r");

					// serviceinfo
					if (d9 == false) {
						lpanel.init();
						d9 = true;
					}
					String active = lpanel.checks();
					String[] lsources = lpanel.sourceStrings();
					for (int i=0; i<4; i++) {
						if (active.charAt(i)=='1') {
							LabelSource ls = lpanel.getSourceByName(lsources[i]);
							if (ls!=null) {
								out.println("\tserviceinfo (name \""+ls.getName()+"\"\r");
								out.println("\t\tshortname \""+ls.getShortname()+"\"\r");
								out.println("\t\tbureauURL \""+ls.getBureauURL()+"\"\r");
								if (ls.getRatfile()!=null) {
									if (umode)
										out.println("\t\tbureauUnavailable \"PASS\"\r");
									else
										out.println("\t\tbureauUnavailable \"FAIL\"\r");
									out.println("\t\tratfile \""+ls.getRatfile()+"\t\t\")\r");
								}
								else {
									if (umode)
										out.println("\t\tbureauUnavailable \"PASS\")\r");
									else
										out.println("\t\tbureauUnavailable \"FAIL\")\r");
								}
								newprof.addLSource(lsources[i]);
							}
						}
					}
					lpanel.setName(filename);

					Vector newrats = newprof.getRats();
					Vector newbool = newprof.getBools();
					Vector passrulz = new Vector();
					Vector blockrulz = new Vector();
					Vector boolrulz = new Vector();
					if (!newrats.isEmpty()) {
						Enumeration erats = newrats.elements();
						Enumeration bees = null;
						if (!newbool.isEmpty()) {
							bees = newbool.elements();
						}
						StringBuffer passstring = new StringBuffer("");
						StringBuffer blockstring = new StringBuffer("");
						boolean haspass = false;
						boolean hasblock = false;
						while (erats.hasMoreElements()) {
							String theout = (String)erats.nextElement();
							String realname = mainPanel8.findFullName(theout);
							Service Ser = (Service)serlist.get(realname);

							int firstdot = realname.indexOf(".");
							String norat = realname;
							if (firstdot!=-1)
								norat = realname.substring(0, firstdot);
							/* out.print(Ser.getFilter(theout, abmode, incmode).
								toRulzString(norat)); */
							Filter thefil = Ser.getFilter(theout, abmode, incmode);
							String pas = thefil.getPassRulz(norat);
							String bloc = thefil.getBlockRulz(norat);
							String bol = null;
							if (bees!=null) {
								if (bees.hasMoreElements()) {
									bol = (String)bees.nextElement();
									// out.println(bol+"\r");								
								}
							}
							if (pas!=null)
								passrulz.addElement(pas);
							else
								passrulz.addElement("");
							if (bloc!=null)
								blockrulz.addElement(bloc);
							else
								blockrulz.addElement("");
							if (bol!=null)
								boolrulz.addElement(bol);
							else
								boolrulz.addElement("");

							// print out the combined filter

						/* 	boolean notblank = false;
							Enumeration blankenum = passrulz.elements();
							while (blankenum.hasMoreElements()) {
								if (!blankenum.nextElement().toString().equals(""))
									notblank = true;
							}

							if (notblank)
								out.print("\tFilter (\r\n\t\tPass \"(");
							else
								out.print("\tFilter (\r\n\t\tPass \"");*/

							/* if (!haspass)
								out.print("Unless-Prohibited\"\r\n");
							else
								out.print(")\"\r\n");	 */

							/* notblank = false;
							blankenum = blockrulz.elements();
							while (blankenum.hasMoreElements()) {
								if (!blankenum.nextElement().toString().equals(""))
									notblank = true;
							}

							if (notblank) {
								out.print("\t\tBlock \"(");	*/

								// out.print(")\"\r\n");
							// }
							// out.print("\t\t)\r\n");

							newprof.putState(Ser.getFilter(theout).toString());
							File fileobj = pr.lookupFile(realname);
							String fstring = fileobj.toString();
							newprof.addFile(fstring);
							newprof.putFullName(realname);
						}

						int vsize = passrulz.size();
						int bsize = boolrulz.size();
						for (int i=0; i<vsize; i++) {
							if (!passrulz.elementAt(i).toString().equals("")) {
								if ((i!=0) && 
									(!boolrulz.elementAt(i-1).toString().equals(""))) {
									passstring.append(") "+boolrulz.elementAt(i-1)+" (");
								}
								if (i==0) {
									for (int j=0; j<bsize-1; j++) {
										passstring.append("(");
									}
								}
								passstring.append((String)passrulz.elementAt(i));
								if ((i<bsize) && (i!=0)) 
									passstring.append(")");
								haspass = true;
							}
						}

						for (int i=0; i<vsize; i++) {
							if (!blockrulz.elementAt(i).toString().equals("")) {
								if ((i!=0) && 
									(!boolrulz.elementAt(i-1).toString().equals(""))) {
									blockstring.append(") "+boolrulz.elementAt(i-1)+" (");
								}
								if (i==0) {
									for (int j=0; j<bsize-1; j++) {
										blockstring.append("(");
									}
								}
								blockstring.append((String)blockrulz.elementAt(i));
								if ((i<bsize) && (i!=0))
									blockstring.append(")");
								hasblock = true;
							}
						}

						// generate the output
						if (haspass) {
							out.print("\tFilter (\r\n\t\tPass \"(");
							out.print(passstring);
							out.print(")\"\r\n");
						}
						else
							out.print("\tFilter (\r\n\t\tPass \"Unless-Prohibited\"\r\n");
						if (hasblock) {
							out.print("\t\tBlock \"(");
							out.print(blockstring);
							out.print(")\"\r\n");
						}
						out.print("\t\t)\r\n");
					}

					// end of file
					out.println("\t)\r");
					out.println(")\r");

					proftable.put(filename, newprof);
					if (!pros.contains(filename))
						pros.addElement(filename);
					pr.addPair(filename, new File(dirname, filename));
					System.out.println(pr.toString());
					if (curcard.equals("PM")) {
						initDemo8(eightmode, true);
						validate();
					}
					out.close();
					fos.close();
				}
				catch (IOException e) {
					throw new RuntimeException("Error in writing file" + filename);
				}
      }
    }
  }

	private void SaveRatingsRulz() {
    Service Ser = (Service)serlist.get(curcard);
    if (Ser==null) {
      System.out.println("error -- not on service page");
			System.out.println("curcard = "+curcard);
      ErrorWindow ew = new ErrorWindow(this, "Can only Save Ratings while "+
				       "on a Service Page");
      return;
    }
    FileDialog fd = new FileDialog(this, "Save As...", FileDialog.SAVE);
    fd.setFile("");
    fd.setDirectory(opendir);
    fd.show();
    String filename = fd.getFile();
		String dirname = fd.getDirectory();
    if (filename!=null) {
      // hack to fix bug in Win32 FileDialog (maybe others...)
      if (filename.endsWith(".*.*"))
				{
					filename=filename.substring(0,filename.length()-4);
				}
      try {
				FileOutputStream fos = new FileOutputStream(filename);
				PrintStream out = new PrintStream(fos);
				int firstdot = curcard.indexOf(".");
				String norat = curcard;
				if (firstdot!=-1)
					norat = curcard.substring(0, firstdot);
				out.println("(\r");
				Filter sfil = Ser.getFilter(curcard, abmode, incmode);
				out.print(sfil.toRulzString(norat));
				out.println("rating-system\t\""+sfil.getRatingsystem()+"\"\r");
				out.println(")\r");
				out.close();
				fos.close();
			}
      catch (IOException e) {
				throw new RuntimeException("Error in writing file" + filename);
      }
			int thespace = curcard.indexOf(" ");
			String oldname = curcard.substring(thespace+1);
			String sername = curcard.substring(0, thespace);
			String newname = sername+" "+filename;
			System.out.println("Untitled");
			inits.remove(curcard);
			Service s = (Service)serlist.remove(curcard);
			Panel thepanel = (Panel)panellist.remove(curcard);
			cardPanel.remove(thepanel);
			removeSerMenu(curcard);
			panellist.put(newname, thepanel);
			cardPanel.add(newname, thepanel);
			serlist.put(newname, s);
			inits.put(newname, new Integer(3));
 			demomenu.add(new MenuItem(newname.trim()));
			setTitle(newname);
			curcard = newname;
			cl.show(cardPanel, newname);
			SDesc.enable();
			validate();
			pr.addPair(curcard, new File(dirname, filename));
			System.out.println(pr.toString());
    }
  }

  private void OpenRulz() {
    FileDialog fd = new FileDialog(this, "Open...", FileDialog.LOAD);
    fd.setFile("*.rulz");
    /* File testfile = new File(opendir+filesep+"pro_files");
    if (testfile.isDirectory()) {
      fd.setDirectory(opendir+filesep+"pro_files");
    } else {
      fd.setDirectory(opendir);
    }		 */
    fd.show();

    String filename=fd.getFile();
		String dirname = fd.getDirectory();

		FileInputStream fis;
		try {
			fis = new FileInputStream(filename);
		}
		catch (Exception ex) {
			System.out.println("OpenRULZ error");
			return;
		}
		SExprStream p = new SimpleSExprStream(fis);
		p.setListsAsVectors(true);
		Object e;
		try {
			e = p.parse();
		}
		catch (Exception ex) {
			System.out.println("SExprParserException in OpenRULZ");
			return;
		}
    // SimpleSExprStream.printExpr(e, System.out);
		// System.out.println(((Vector)e).toString());
    // System.out.println();
		Enumeration vlist = ((Vector)e).elements();
		vlist.nextElement();
		Enumeration vlist2 = ((Vector)vlist.nextElement()).elements();
		// while (vlist2.hasMoreElements()) {
			// System.out.println("Clause: "+vlist2.nextElement());
			// System.out.println("Value: "+vlist2.nextElement());
		// }

		File itexists = pr.lookupFile(filename);
		if (itexists!=null) {
			File tester = new File(dirname, filename);
			int fnum = findNum(filename, tester);
			switch (fnum) {
				case 0:
					if (dups.get(filename)==null)
						dups.put(filename, new Integer(2));
					else {
						Integer thenum = (Integer)dups.get(filename);
						int numval = thenum.intValue();
						numval++;
						dups.put(filename, new Integer(numval));
					}
					String snum = ((Integer)dups.get(filename)).toString();
					String newfilename = filename+"("+snum+")";
					Profile newprof = new Profile(vlist2, filename, dirname);
					proftable.put(newfilename, newprof);
					pros.addElement(newfilename);
					pr.addPair(newfilename, new File(dirname, filename));
					break;
				case 1:
					Profile newprof1 = new Profile(vlist2, filename, dirname);
					proftable.put(filename, newprof1);
					if (!pros.contains(filename))
						pros.addElement(filename);
					break;
				default:
					String newfilename2 = filename+"("+fnum+")";
					Profile newprof2 = new Profile(vlist2, filename, dirname);
					proftable.put(newfilename2, newprof2);
					if (!pros.contains(newfilename2))
						pros.addElement(newfilename2);
			}
		}
		else {
			Profile newprof = new Profile(vlist2, filename, dirname);
			proftable.put(filename, newprof);
			pros.addElement(filename);
			pr.addPair(filename, new File(dirname, filename));
		}
		System.out.println(pr.toString());
		if (curcard.equals("PM")) {
			initDemo8(eightmode, true);
			validate();
		}
  }

	private void OpenRatingsRulz() {
    FileDialog fd = new FileDialog(this, "Open...", FileDialog.LOAD);
    fd.setDirectory(opendir);
    fd.show();

    String datafilename=fd.getFile();
		String dirname = fd.getDirectory();
    if (datafilename!=null) {
      System.out.println("Ratings Opened");
      System.out.println(datafilename);
			int r = curcard.indexOf(" ");
			if (r==-1) {
				ErrorWindow ew = new ErrorWindow(this, "Can only Load Ratings while "+
							"on a Service Editor Page");
				return;
			}
			String ratfile = curcard.substring(0, r);
			File testfile = new File(opendir+filesep+"rat_files", ratfile);
			WaitWindow ww = new WaitWindow(this, "Loading Ratings...",
							"Loading Ratings...Please Wait.");
			Panel filepanel = new Panel();
			String fullname = ratfile+" "+datafilename;
			testOpenServiceWithName(fullname, filepanel, dirname);
			File itexists = pr.lookupFile(fullname);
			if (itexists!=null) {
				File tester = new File(dirname, datafilename);
				int fnum = findNum(fullname, tester);
				switch (fnum) {
					case 0:
						fullname = fullname+"("+((Integer)dups.get(fullname)).toString()+
							")";
						break;
					case 1:
						break;
					default:
						fullname = fullname+"("+fnum+")";
				}
			}
      Service Ser = (Service)serlist.get(fullname);
      if (Ser==null) {
				System.out.println("Error loading ratings.");
				ErrorWindow ew = new ErrorWindow(this, "Can only Load Ratings while "+
								 "on a Service Editor Page");
				return;
      }
      FileInputStream fis;
      Filter Fil;
      try {
				fis=new FileInputStream(datafilename);
      }
      catch (FileNotFoundException e)
			{
				System.out.println("File not found");
				return;
			}
      catch (IOException e)
			{
				System.out.println("IO Exception");
				return;
			}
			boolean haderr = false;
      try {
				Fil = new Filter(fis, ratfile, true);
				System.out.println(Fil);
				haderr = Ser.setFilter(Fil);
				Ser.resetError();
      }
      catch (PICSException e)
			{
				System.out.println("PICS Filter Parsing Error:");
				System.out.println(e);
				haderr = true;
			}
      catch (IOException e)
			{
				System.out.println("IO error");
				haderr = true;
			}
      try {
				fis.close();
      }
      catch (IOException ei) {
				System.out.println("Closing error");
      }
			if (haderr)	{
				ww.hide();
				ww.dispose();
				System.out.println(pr.toString());
				return;
			}
			inits.put(fullname, new Integer(2));
			panellist.put(fullname, filepanel);
			cardPanel.add(fullname, filepanel);
			removeSerMenu(fullname);
			demomenu.add(new MenuItem(fullname.trim()));
			ww.hide();
			ww.dispose();
			postEvent(new Event(demomenu, Event.ACTION_EVENT, fullname));
			pr.addPair(curcard, new File(dirname, datafilename));
			System.out.println(pr.toString());	 
    }
  }

	void RemoteOpenAllRulz(String input, String parent) {
		Profile theprof = (Profile)proftable.get(input);
		if (theprof!=null) {
			// is a profile
			gotoPM();
			System.out.println("tree: open profile");
			OpenAllRulz(input);
		}
		else {
			// is a primitive profile
			System.out.println("tree: open ratings");
			WaitWindow ww = new WaitWindow(this, "Loading Ratings Editor...", 
				"Loading Ratings Editor...Please Wait.");
			Profile pprof = (Profile)proftable.get(parent);
			String realfullname = null;
			if (pprof!=null) {
				Vector profsi = pprof.getServiceInfos();
				if (!profsi.isEmpty()) {
					Enumeration sis = profsi.elements();
					while (sis.hasMoreElements()) {
						LabelSource ls = (LabelSource)sis.nextElement();
						if (ls.getShortname().equals(input)) {
							// have the correct LabelSource
							Panel filepanel = new Panel();
							String fullname = ls.getShortname()+".rat "+parent;
							realfullname = fullname;
							if (ls.getRmode()==true) {
								System.out.println(ls.getShortname()+" rmode = true");
								testOpenServiceWithName(fullname, filepanel, "");
							}
							else {
								System.out.println(ls.getShortname()+" rmode = false");
								testOpenServiceWithData(ls, filepanel, fullname);
							}
							inits.put(fullname, new Integer(2));
							panellist.put(fullname, filepanel);
							cardPanel.add(fullname, filepanel);
							removeSerMenu(fullname);
							demomenu.add(new MenuItem(fullname.trim()));
							Service Ser = (Service)serlist.get(fullname);
							if (Ser==null) {
								System.out.println("Error loading ratings.");
								return;
							}
							Filter Fil = null;
							StringBuffer filterinput = new StringBuffer();
							filterinput.append("( Filter ( Pass \"");
							filterinput.append(pprof.getPass());
							filterinput.append("\"");
							if (pprof.getBlock()!=null)
								filterinput.append("Block\""+pprof.getBlock()+"\"");
							filterinput.append(")");
							filterinput.append("rating-system \""+Ser.getRatingsystem()+"\"");
							filterinput.append(")");
							StringBufferInputStream realinput;
							realinput = new StringBufferInputStream(filterinput.toString());
							try {
								Fil = new Filter(realinput, ls.getShortname()+".rat", false);
								System.out.println(Fil);
								Ser.setFilter(Fil);
							}
							catch (PICSException e) {
								System.out.println("PICS Filter Parsing Error:");
								System.out.println(e);
							}
							catch (IOException e) {
								System.out.println("IO error");
							}
							System.out.println(pr.toString());
							break;
						}
					}
				}
			}
			ww.hide();
			ww.dispose();
			postEvent(new Event(demomenu, Event.ACTION_EVENT, realfullname));
		}
	}
	
	private void OpenAllRulz(String input) {
		String name = null;
		if (!input.equals("")) 
			name = input;
		else 
			name = mainPanel8.getEdited();
    if (!name.equals("")) {
      Profile theprof = (Profile)proftable.get(name);
      if (theprof!=null) {
				WaitWindow ww = new WaitWindow(this, "Opening Files...",
							"Opening Files...Please Wait.");
				Vector profsi = theprof.getServiceInfos();
				boolean noerr = true;
				boolean haderr = false;
				if (!profsi.isEmpty()) {
					Enumeration sis = profsi.elements();
					while (sis.hasMoreElements()) {
						LabelSource ls = (LabelSource)sis.nextElement();
						ww.changeMessage("Opening Ratings File: "+ls.getShortname()+
							".rat...");
						Panel filepanel = new Panel();
						String fullname = ls.getShortname()+".rat "+name;
						if (ls.getRmode()==true) {
							System.out.println(ls.getShortname()+" rmode = true");
							testOpenServiceWithName(fullname, filepanel, "");
						}
						else {
							System.out.println(ls.getShortname()+" rmode = false");
							testOpenServiceWithData(ls, filepanel, fullname);
						}
						inits.put(fullname, new Integer(2));
						panellist.put(fullname, filepanel);
						cardPanel.add(fullname, filepanel);
						removeSerMenu(fullname);
						demomenu.add(new MenuItem(fullname.trim()));
						Service Ser = (Service)serlist.get(fullname);
						if (Ser==null) {
							System.out.println("Error loading ratings.");
							return;
						}
						Filter Fil = null;
						StringBuffer filterinput = new StringBuffer();
						filterinput.append("( Filter ( Pass \"");
						filterinput.append(theprof.getPass());
						filterinput.append("\"");
						if (theprof.getBlock()!=null)
							filterinput.append("Block\""+theprof.getBlock()+"\"");
						filterinput.append(")");
						filterinput.append("rating-system \""+Ser.getRatingsystem()+"\"");
						filterinput.append(")");
						StringBufferInputStream realinput;
						realinput = new StringBufferInputStream(filterinput.toString());
						try {
							Fil = new Filter(realinput, ls.getShortname()+".rat", false);
							System.out.println(Fil);
							Ser.setFilter(Fil);
						}
						catch (PICSException e) {
							System.out.println("PICS Filter Parsing Error:");
							System.out.println(e);
						}
						catch (IOException e) {
							System.out.println("IO error");
						}
						// noerr = PMOpenService(fullrname, (String)srat.nextElement());
						// can't use the PICSRegistry here because the ratings info was 
						// from the .rulz file and not from a seperate file.
						/* pr.addPair(fullname, new File(theprof.getDirname(), 
							theprof.getFilename())); */
						System.out.println(pr.toString());
						/* if (!noerr)
							haderr = true;	*/
					}
				}
				urls.setText("");
				ww.changeMessage("Loading URL lists...");
				Vector profurl = theprof.getURLs();
				if (!profurl.isEmpty()) {
					Enumeration urat = profurl.elements();
					while (urat.hasMoreElements()) {
						String uname = (String)urat.nextElement();
						urls.appendText(uname+"\n");
					}
				}
				urls2.setText("");
				Vector profurl2 = theprof.getURLs2();
				if (!profurl2.isEmpty()) {
					Enumeration urat2 = profurl2.elements();
					while (urat2.hasMoreElements()) {
						String uname2 = (String)urat2.nextElement();
						urls2.appendText(uname2+"\n");
					}
				}
				if (de==null)
					de = new DescEditor(this);
				de.putDesc(theprof.getDesc());
				de.putSource(theprof.getSourceURL());
				Vector ls = theprof.getLSources();
				if (!ls.isEmpty()) {
					ww.changeMessage("Loading Label Sources...");
					Enumeration lsrat = ls.elements();
					int counter = 1;
					if (d9 == false) {
						lpanel.init();
						d9 = true;
					}
					while (lsrat.hasMoreElements()) {
						String lsname = (String)lsrat.nextElement();
						System.out.println("lsname: "+lsname);
						lpanel.makeSetting(lsname, counter);
						counter++;
					}
					while (counter<5) {
						lpanel.emptySetting(counter);
						counter++;
					}
				}	 
				if (haderr)
					ErrorWindow ewin = new ErrorWindow(this, "There was an error in "+
										 "loading these files.  Please "+
										 "try again.", 400);
				initDemo8(eightmode, true);
				validate();
				ww.hide();
				ww.dispose();
      }
    }
  }

	private void testOpenServiceWithData(LabelSource ls, Panel testpanel, 
		String filename)
  {
    Service Ser = null;
    boolean SimpleFiltering=false;
		StringBufferInputStream fis = 
			new StringBufferInputStream(ls.getUnparsedRatfile());
		
    try
    {
			Ser=new Service(fis, this);
    }
    catch (PICSException e)
    {
			try
			{fis.close();}
			catch (IOException ei) {System.out.println("Closing error");}
			System.out.println("PICS Service Parsing Error:");
			System.out.println(e);
    }
    catch (IOException e)
    {System.out.println("IO error");}
    // Put the Interface Widgets of the New Service
    Ser.newInterface(testpanel,SimpleFiltering, status);
		File itexists = pr.lookupFile(filename);
		if (itexists!=null) {
			File tester = null;
			int thespace = filename.indexOf(" ");
			String testname = filename.substring(thespace+1);
			tester = new File(opendir+filesep, testname);
			int fnum = findNum(filename, tester);
				switch (fnum) {
					case 0:
						if (dups.get(filename)==null)
							dups.put(filename, new Integer(2));
						else {
							Integer thenum = (Integer)dups.get(filename);
							int numval = thenum.intValue();
							numval++;
							dups.put(filename, new Integer(numval));
						}
						String snum = ((Integer)dups.get(filename)).toString();
						serlist.put(filename+"("+snum+")", Ser);
						break;
					case 1:
						serlist.put(filename, Ser);
						break;
					default:
						serlist.put(filename+"("+fnum+")", Ser);
				}
		}
		else
			serlist.put(filename, Ser);
		System.out.println("serlist size: "+serlist.size());
		lpanel.addSource(ls);
    testpanel.validate();
    try {
      fis.close();
    }
    catch (Exception e) {
      System.out.println("Error parsing ratfile info");
    }
  }

	private void mergeFilters(Vector profpro, Profile theprof) {
		// open each .pro file.
		Enumeration epro = profpro.elements();
		while (epro.hasMoreElements()) {
			String pename = (String)epro.nextElement();
			if (pros.indexOf(pename)==-1) {
				// Profile newprof = new Profile(pename, opendir);
				FileInputStream fis;
				try {
					fis = new FileInputStream(pename);
				}
				catch (Exception ex) {
					System.out.println("OpenAllRulz error");
					return;
				}
				SExprStream p = new SimpleSExprStream(fis);
				p.setListsAsVectors(true);
				Object e;
				try {
					e = p.parse();
				}
				catch (Exception ex) {
					System.out.println("SExprParserException in OpenAllRulz");
					return;
				}
				Enumeration vlist = ((Vector)e).elements();
				vlist.nextElement();
				Enumeration vlist2 = ((Vector)vlist.nextElement()).elements();
				Profile newprof = new Profile(vlist2, pename, opendir);
				pr.addPair(pename, new File(opendir, pename));
				proftable.put(pename, newprof);
				pros.addElement(pename);
			}
		}

		// get each filter clause.

		epro = profpro.elements();
		Vector passes = new Vector();
		Vector blocks = new Vector();
		passes.addElement(theprof.getPass());
		
		while (epro.hasMoreElements()) {
		}

		// merge.
		// mutate the Profile.
	}

}
