// LabelLoaderInterpreter.java
// by Yang-hua Chu
// last update: 10/11/96

package w3c.pics.referee;

import java.io.* ;
import java.net.*;
import java.util.*;
import w3c.pics.util.*;
import w3c.pics.label.*;

public class LabelLoaderInterpreter implements RefereeInterpreter {
  
  public Hashtable curState = new Hashtable();
  
  public void initialize (Object o) 
  {
    return;
  }

  public void setPolicy(Object policy)
  {
    curState.put("LABELS", (SExp) policy);
  }


  public void setModuleDatabase(ModuleDatabase moduleDB)
  {  
    curState.put("MODULE-DATABASE", moduleDB);
  }


  public ReturnedValues invoke(Vector v)
    throws RefereeException
  {
    ((SExp)curState.get("LABELS")).reset();  // a bug in SExp
    curState.put("STATEMENT-LIST", v.elementAt(0));
    curState.put("URL", v.elementAt(1));
    curState.put("SERVICE-URL", v.elementAt(2));
    SExp sexp = new SExp();
    sexp.parse((String)v.elementAt(3));
    curState.put("SOURCE-LIST", sexp);
    
    SExp content = (SExp) curState.get("LABELS");
    ReturnedValues rval = new ReturnedValues();

    for (int i=1; i<=content.size(); i++) {
      LabelParser lp = new LabelParser();
      PICSLabelList ll = new PICSLabelList();
      try { ll.parse(content.getSExp(i)); }
      catch (PICSParseException e) {
	throw new RefereeException(e.getMessage()); }
      lp.addLabel(ll);
      SExp res = new SExp();
      try { 
	  res = lp.search((URL)curState.get("URL"), "...", true); }
      catch (Exception e) {
	throw new RefereeException(e.getMessage());
      }
      SExp stmt_header = new SExp(SExp.SEXP_SEXP);
      stmt_header.addSExp(new SExp(SExp.SEXP_STRING, "load-label"));
      stmt_header.addSExp(new SExp(SExp.SEXP_STRING, 
				   ((URL)curState.get("URL")).toString()));
      stmt_header.addSExp(((SExp)curState.get("SOURCE-LIST")).getSExp(1));
      SExp stmt_content = new SExp(SExp.SEXP_SEXP);
      stmt_content.addSExp(stmt_header);
      stmt_content.addSExp(res.getSExp(1));
      Statement stmt = new Statement();
      stmt.setContent(stmt_content);
      rval.getStatementList().addStatement(stmt);
      rval.setTriValue(new TriValue (true));
    }
    return rval;
  }
}

