// RefereeModule.java
// by Yang-hua Chu
// last update: 6/11/97

package w3c.pics.referee;

import java.util.*;

public class RefereeModule {
  
  private RefereeInterpreter interpreters[] = {};
  private Object policy = null;
  private ModuleDatabase moduleDB = new ModuleDatabase();


  public void setPolicy(Object p)
  {
    policy = p;
  }
  

  public void setInterpreters(RefereeInterpreter RIs[])
  {
    interpreters = RIs;
  }


  public void setModuleDatabase(ModuleDatabase moduleDB)
  {
    this.moduleDB = moduleDB;
  }


  public Object getPolicy()
  {
    return policy;
  }


  public RefereeInterpreter[] getInterpreters()
  {
    return interpreters;
  }


  public void addInterpreter(RefereeInterpreter interpreter)
  {
    int size = interpreters.length;
    RefereeInterpreter ninterpreters[] = new RefereeInterpreter[size+1];
    System.arraycopy(interpreters, 0, ninterpreters, 0, size);
    ninterpreters[size] = interpreter;
    interpreters = ninterpreters;
  }


  // I do not support multi-layer interpreters yet...
  public ReturnedValues invoke(Vector v)
    throws RefereeException
  {
    if (interpreters.length > 1)
      throw new RefereeException("RefereeModule error: unable to invoke" +
				 " more than one interpreters");
    RefereeInterpreter interpreter = interpreters[0];
    if (policy != null)
      interpreter.setPolicy(policy);
    interpreter.setModuleDatabase(moduleDB);
    return interpreter.invoke(v);
  }

  public String toString()
  {
    return ("The policy is " + policy.toString() + "\n" +
	    "The interpreters is " + interpreters[0].toString() + "\n");
  }
    
}



