// URLLoader.java
// by Yang-hua Chu
// last update: 10/11/96

package w3c.pics.referee;

import java.io.* ;
import java.net.*;
import java.util.*;
import w3c.pics.util.*;
import w3c.pics.label.*;
import w3c.www.protocol.http.*;

public class URLLoader implements RefereeInterpreter {
  
  public Hashtable curState = new Hashtable();
  public boolean DEBUG = true;
  
  
  public void initialize (Object filter) 
  {
  }

  public void setPolicy(Object policy)
  {
    curState.put("POLICY", (SExp) policy);
  }


  public void setModuleDatabase(ModuleDatabase moduleDB)
  {  
    curState.put("MODULE-DATABASE", moduleDB);
  }
  
  
  /** 
   * fetch the URL from the network.  The Trivalue is true if the fetch 
   * succeeds, false otherwise.
   * The Statement-List is a single statement of the form
   *        ( ( <Reply object> ) )
   */
  public ReturnedValues invoke(Vector v)
    throws RefereeException
  {
    Class hostFilter;
    
    ReturnedValues rval = new ReturnedValues();
    URL requestedURL = (URL)v.elementAt(0);
    // PropRequestFilter rf = (PropRequestFilter)v.elementAt(1);
    
    HttpManager manager = HttpManager.getManager();
    manager.setGlobalHeader("TrustMgt-Flag", "false");
    URL urls[] = {requestedURL};
    try { 
      hostFilter = Class.forName("w3c.pics.referee.RefereeFilter"); 
    }
    catch (Exception e) {
      e.printStackTrace();
      System.out.println("unable to establish exclude filter");
      return rval;
    }
    RequestFilter rf = manager.getGlobalFilter(hostFilter);
    manager.setFilter(null, urls, rf);
    Request tmp_request = manager.createRequest();
    tmp_request.setURL(requestedURL);
    tmp_request.setMethod("GET");

    rval.setTriValue(new TriValue('t'));
    Reply reply;
    try {
      reply = manager.runRequest(tmp_request);    
    } catch (HttpException e) {
      if (DEBUG) 
	System.out.println("ERROR at "+this.getClass().getName() + 
			   "the URL at " + requestedURL.toString() + 
			   "cannot be found");
      rval.setTriValue(new TriValue('f'));
      return rval;
    }

    SExp stmt_header = new SExp(SExp.SEXP_SEXP);
    SExp stmt_content = new SExp(SExp.SEXP_SEXP);
    stmt_content.addObject(reply);
    Statement stmt = new Statement();
    stmt.setContent(stmt_content);
    StatementList stmt_list = new StatementList();
    stmt_list.addStatement(stmt);
    rval.setStatementList(stmt_list);
    return rval;
  }
}






